#include "../../plugin.hpp"
#include <stdio.h>

#define sizeofa(array) (sizeof(array)/sizeof(array[0]))
#define FAR165_INFO_SIZE 336

#define malloc(size) HeapAlloc(GetProcessHeap(),HEAP_ZERO_MEMORY,size)
#define free(ptr) ((ptr)?HeapFree(GetProcessHeap(),0,ptr):0)
#define realloc(ptr,size) ((size)?((ptr)?HeapReAlloc(GetProcessHeap(),HEAP_ZERO_MEMORY,ptr,size):HeapAlloc(GetProcessHeap(),HEAP_ZERO_MEMORY,size)):(HeapFree(GetProcessHeap(),0,ptr),(void *)0))

enum
{
  mName,
  mDone,
  mWell,
  mLevUnknown,
  mLev0,
};

PluginStartupInfo Info;
bool IsOldFAR=true;

static const char *GetMsg(int MsgId)
{
  return(Info.GetMsg(Info.ModuleNumber,MsgId));
};

void WINAPI SetStartupInfo(const struct PluginStartupInfo *Info)
{
  memset(&::Info,0,sizeof(::Info));
  memmove(&::Info,Info,(Info->StructSize>(int)sizeof(::Info))?sizeof(::Info):Info->StructSize);
  if(Info->StructSize>FAR165_INFO_SIZE)
    IsOldFAR=false;
}

void WINAPI GetPluginInfo(struct PluginInfo *Info)
{
  if(!IsOldFAR)
  {
    Info->StructSize=sizeof(*Info);
    Info->Flags=0;
    static const char *PluginMenuStrings[1];
    PluginMenuStrings[0]=GetMsg(mName);
    Info->PluginMenuStrings=PluginMenuStrings;
    Info->PluginMenuStringsNumber=sizeof(PluginMenuStrings)/sizeof(PluginMenuStrings[0]);
  }
}

HANDLE WINAPI _export OpenPlugin(int OpenFrom,int Item)
{
  static char hotkeys[]="0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ";
  if(!IsOldFAR)
  {
    HKL *data=NULL;
    int count=GetKeyboardLayoutList(0,NULL);
    if(count)
    {
      data=(HKL *)HeapAlloc(GetProcessHeap(),HEAP_ZERO_MEMORY,count*sizeof(HKL));
      if(data&&GetKeyboardLayoutList(count,data)==count)
      {
        FarMenuItem *MenuItems=(FarMenuItem *)HeapAlloc(GetProcessHeap(),HEAP_ZERO_MEMORY,(count+2)*sizeof(FarMenuItem));
        if(MenuItems)
        {
          int top=(count<11)?count:10;
          for(int i=0;i<top;i++)
            sprintf(MenuItems[i].Text,"%c. %s",hotkeys[i],GetMsg(mLev0+i));
          for(int i=top;i<count;i++)
            if(i<(int)strlen(hotkeys))
              sprintf(MenuItems[i].Text,"%c. %s",hotkeys[i],GetMsg(mLevUnknown));
            else
              sprintf(MenuItems[i].Text,"%c. %s",' ',GetMsg(mLevUnknown));
          MenuItems[0].Selected=TRUE;
          int MenuCode=Info.Menu(Info.ModuleNumber,-1,-1,0,FMENU_WRAPMODE|FMENU_AUTOHIGHLIGHT,GetMsg(mName),NULL,NULL,NULL,NULL,MenuItems,count);
          if(MenuCode>=0)
          {
            PostMessage((HWND)Info.AdvControl(Info.ModuleNumber,ACTL_GETFARHWND,0),WM_INPUTLANGCHANGEREQUEST,0,(LPARAM)data[MenuCode]);
            const char *MsgItems[]={"",GetMsg(mDone),GetMsg(mWell)};
            Info.Message(Info.ModuleNumber,0,NULL,MsgItems,sizeofa(MsgItems),1);
          }
          HeapFree(GetProcessHeap(),0,MenuItems);
        }
        HeapFree(GetProcessHeap(),0,data);
      }
    }
  }
  return INVALID_HANDLE_VALUE;
}

int WINAPI _export GetMinFarVersion(void)
{
  return MAKEFARVERSION(1,70,1282);
}

#ifdef __cplusplus
extern "C"{
#endif
  bool WINAPI DllMainCRTStartup(HANDLE hDll,DWORD dwReason,LPVOID lpReserved);
#ifdef __cplusplus
};
#endif

bool WINAPI DllMainCRTStartup(HANDLE hDll,DWORD dwReason,LPVOID lpReserved)
{
  return true;
}
